/* $Id: rapi2.c 2365 2006-04-09 14:56:49Z voc $ */
#undef __STRICT_ANSI__
#define _GNU_SOURCE
#include "rapi2/rapi2_api.h"
#include "rapi_indirection.h"
#include <stdlib.h>

/* The rapi2 application interface indirection */
struct rapi_ops_s rapi2_ops =
{
#ifndef SWIG
        &_CeCloseHandle2,                 /* CeCloseHandle */
        &_CeCreateFile2,                  /* CeCreateFile */
        &_CeReadFile2,                    /* CeReadFile */
        &_CeWriteFile2,                   /* CeWriteFile */
#endif /* SWIG */
        /*
         * File management functions
        */
#ifndef SWIG
        &_CeCopyFileA2,                   /* CeCopyFileA */
        &_CeCopyFile2,                    /* CeCopyFile */
        &_CeCreateDirectory2,             /* CeCreateDirectory */
        &_CeDeleteFile2,                  /* CeDeleteFile */
        &_CeFindAllFiles2,                /* CeFindAllFiles */
        NULL,                             /* CeFindFirstFile */
        NULL,                             /* CeFindNextFile */
        NULL,                             /* CeFindClose */
        &_CeGetFileAttributes2,           /* CeGetFileAttributes */
        &_CeGetFileSize2,                 /* CeGetFileSize */
        &_CeGetSpecialFolderPath2,        /* CeGetSpecialFolderPath */
        &_CeMoveFile2,                    /* CeMoveFile */
        &_CeRemoveDirectory2,             /* CeRemoveDirectory */
        NULL,                             /* CeSetFileAttributes */
        NULL,                             /* CeSHCreateShortcut */
        NULL,                             /* CeSyncTimeToPc */
#endif /* SWIG */
        /*
         * Database functions
        */
#ifndef SWIG
        NULL,                             /* CeCreateDatabase */
        NULL,                             /* CeDeleteDatabase */
        NULL,                             /* CeFindAllDatabases */
        NULL,                             /* CeFindFirstDatabase */
        NULL,                             /* CeFindNextDatabase */
        NULL,                             /* CeOpenDatabase */
        NULL,                             /* CeReadRecordProps */
        NULL,                             /* CeSeekDatabase */
        NULL,                             /* CeWriteRecordProps */
        NULL,                             /* CeDeleteRecord */
        NULL,                             /* CeSetDatabaseInfo */
#endif /* SWIG */
        /*
         * Registry
        */
#ifndef SWIG
        NULL,                             /* CeRegCreateKeyEx */
        NULL,                             /* CeRegOpenKeyEx */
        NULL,                             /* CeRegCloseKey */
        NULL,                             /* CeRegQueryInfoKey */
        NULL,                             /* CeRegQueryValueEx */
        NULL,                             /* CeRegEnumValue */
        NULL,                             /* CeRegEnumKeyEx */
        NULL,                             /* CeRegSetValueEx */
        /*
        * Convenience functions for easy registry access
        */
        NULL,                             /* rapi_reg_create_key */
        NULL,                             /* rapi_reg_open_key */
        NULL,                             /* rapi_reg_query_dword */
        NULL,                             /* rapi_reg_query_string */
        NULL,                             /* rapi_reg_set_dword */
        NULL,                             /* rapi_reg_set_string */
#endif /* SWIG */
        /*
         * Misc functions
        */
#ifndef SWIG
        NULL,                             /* CeCheckPassword */
        NULL,                             /* CeCreateProcess */
        NULL,                             /* CeGetStoreInformation */
        NULL,                             /* CeGetSystemInfo */
        NULL,                             /* CeGetSystemPowerStatusEx */
        NULL,                             /* CeGetVersionEx */
        NULL,                             /* CeOidGetInfo */
        NULL,                             /* CeProcessConfig */
        NULL,                             /* CeStartReplication */
        NULL,                             /* CeGetSystemMemoryDivision */
        NULL,                             /* CeSetSystemMemoryDivision */
        NULL,                             /* CeRegCopyFile */
        NULL,                             /* CeRegRestoreFile */
        NULL,                             /* CeKillAllApps */
#endif /* SWIG */
        /*
         * CeRapiInvoke stuff
        */
#ifndef SWIG
        NULL,                             /* IRAPIStream_Release */
        NULL,                             /* IRAPIStream_Read */
        NULL,                             /* IRAPIStream_Write */
        /* IRAPIStream_GetRawSocket, */   /* IRAPIStream_GetRawSocket */
        NULL,                             /* CeRapiInvoke */
        NULL,                             /* CeRapiInvokeA */
#endif /* SWIG */
};
